#ifndef COMMON_INCLUDE
#define COMMON_INCLUDE

// #define GLEW_STATIC

#include <boost/smart_ptr.hpp>
#include <boost/any.hpp>
#include <cassert>
#include <typeinfo>
#include <string>
#include <vector>
#include "ist/ist_net.h"
#include "ist/ist_sys.h"
#include "ist/ist_i3d.h"
#include "ist/random.h"

#define VERSION_STRING "empire_tohu 0.1.5 20060108"


typedef size_t frame_t;
typedef size_t category_t;
typedef size_t gobj_id;
typedef boost::intrusive_ptr<ist::ITexture> texture_ptr;
typedef boost::intrusive_ptr<ist::IPolygonModel> pmodel_ptr;
typedef boost::intrusive_ptr<ist::IMorphModel> amodel_ptr;
typedef boost::intrusive_ptr<ist::ICachedMorphModel> cmodel_ptr;



class IGameObject;
class IVisible;
class ISelectable;
class IBreakable;

class IGroup;
class IUnit;
class IBuilding;
class IMaterial;
class IParticle;
class IBullet;
class IMenu;
class IFaction;

class IRequest;

typedef boost::intrusive_ptr<IGameObject> gobj_ptr;
typedef boost::intrusive_ptr<IVisible>    visible_ptr;
typedef boost::intrusive_ptr<ISelectable> selectable_ptr;
typedef boost::intrusive_ptr<IBreakable>  breakable_ptr;

typedef boost::intrusive_ptr<IGroup>      group_ptr;
typedef boost::intrusive_ptr<IUnit>       unit_ptr;
typedef boost::intrusive_ptr<IBuilding>   building_ptr;
typedef boost::intrusive_ptr<IMaterial>   material_ptr;
typedef boost::intrusive_ptr<IParticle>   particle_ptr;
typedef boost::intrusive_ptr<IBullet>     bullet_ptr;
typedef boost::intrusive_ptr<IMenu>       menu_ptr;
typedef boost::intrusive_ptr<IFaction>    faction_ptr;

typedef boost::intrusive_ptr<IRequest>    request_ptr;


typedef faction_ptr  (*faction_creator)();
typedef unit_ptr     (*unit_creator)(faction_ptr);
typedef building_ptr (*building_creator)(faction_ptr);
typedef material_ptr (*material_creator)();





#endif
