#ifndef MACRO_INCLUDE
#define MACRO_INCLUDE

#define Exit()                        GetIGame().exit()
#define GetAxis(i)                    GetIGame().getAxis(i)
#define GetButton(i)                  GetIGame().getButton(i)
#define GetWindowWidth()              GetIGame().getWindowWidth()
#define GetWindowHeight()             GetIGame().getWindowHeight()
#define DrawQuad(a,b,c,d)             GetIGame().drawQuad(a,b,c,d)
#define DrawRect(a,b)                 GetIGame().drawRect(a,b)
#define DrawFont(x,y,m)               GetIGame().drawFont(x, y, m)
#define GetFont()                     GetIGame().getFont()
#define LoadDSO(name)                 GetIGame().loadDSO(name)
#define GetRand()                     GetIGame().getRand()
#define IsShiftKeyDown()              GetIGame().isShiftKeyDown()
#define IsAltKeyDown()                GetIGame().isAltKeyDown()
#define IsCtrlKeyDown()               GetIGame().isCtrlKeyDown()

#define AddFactionCreator(name, fc)   GetIGame().addFactionCreator(name, fc)
#define AddUnitCreator(name, fc)      GetIGame().addUnitCreator(name, fc)
#define AddBuildingCreator(name, fc)  GetIGame().addBuildingCreator(name, fc)
#define AddMaterialCreator(name, fc)  GetIGame().addMaterialCreator(name, fc)

#define GetWorld(name)                GetIGame().getWorld(name)
#define GetCurrentWorld()             GetIGame().getCurrentWorld()
#define SetCurrentWorld(name)         GetIGame().setCurrentWorld(name)
#define RequestSetCurrentWorld(name)  GetIGame().requestSetCurrentWorld(name)

#define CreateFactionR(name)          GetIGame().createFaction(name)
#define CreateUnitR(name, f)          GetIGame().createUnit(name, f)
#define CreateBuildingR(name, f)      GetIGame().createBuilding(name, f)
#define CreateMaterialR(name)         GetIGame().createMaterial(name)
#define CreateGroupR(i)               GetIGame().createGroup(i)

#define SetWorldMode(m)               GetCurrentWorld().setMode(m)
#define GetWorldMode()                GetCurrentWorld().getMode()
#define LoadReplay(f)                 GetCurrentWorld().loadReplay(f)
#define SetServerAddress(a)           GetCurrentWorld().setServerAddress(a)
#define SetServerPort(p)              GetCurrentWorld().setServerPort(p)
#define GetServerDatabase()           GetCurrentWorld().getServerDatabase()

#define RegistKeyObserver(k, o)       GetCurrentWorld().registKeyObserver(k, o);
#define DeregistKeyObserver(k, o)     GetCurrentWorld().deregistKeyObserver(k, o);

#define CreateID()                    GetCurrentWorld().createID()
#define CreateFaction(name)           GetCurrentWorld().createFaction(name)
#define CreateUnit(name, f)           GetCurrentWorld().createUnit(name, f)
#define CreateBuilding(name, f)       GetCurrentWorld().createBuilding(name, f)
#define CreateMaterial(name)          GetCurrentWorld().createMaterial(name)
#define CreateGroup(i)                GetCurrentWorld().createGroup(i)

#define SetPlayerFaction(p)           GetCurrentWorld().setPlayerFaction(p)
#define GetPlayerFaction()            GetCurrentWorld().getPlayerFaction()
#define GetNatureFaction()            GetCurrentWorld().getNatureFaction()

#define AddGObj(p)                    GetCurrentWorld().addGObj(p)
#define GetGObj(id)                   GetCurrentWorld().getGObj(id)
#define RouteEvent(e)                 GetCurrentWorld().sendEvent(e)
#define StopSendingUpdateEvent()      GetCurrentWorld().stopSendingUpdateEvent()
#define StartSendingUpdateEvent()     GetCurrentWorld().startSendingUpdateEvent()

#define InsertToCharacterGrid(p, g)   GetCurrentWorld().insertToCharacterGrid(p, g)
#define EraseFromCharacterGrid(p, g)  GetCurrentWorld().eraseFromCharacterGrid(p, g)
#define MoveCharacterGrid(b, a, g)    GetCurrentWorld().moveCharacterGrid(b, a, g)
#define AddCircleCollision(s, p, r)    GetCurrentWorld().addCircleCollision(s, p, r)
#define RemoveCircleCollision(s, p, r) GetCurrentWorld().removeCircleCollision(s, p, r)

#define GetBlocksByRadius(pos, r)     GetCurrentWorld().getBlocksByRadius(pos, r)
#define GetGObjsInSight()             GetCurrentWorld().getGObjsInSight()
#define GetFactions()                 GetCurrentWorld().getFactions()
#define GetMenus()                    GetCurrentWorld().getMenus()
#define GetCamera()                   GetCurrentWorld().getCamera()
#define GetCameraPos()                GetCurrentWorld().getCameraPos()
#define SetCameraPos(p)               GetCurrentWorld().setCameraPos(p)
#define GetGroundLight()              GetCurrentWorld().getGroundLight()
#define EnableGroundLighting(e)       GetCurrentWorld().enableGroundLighting(e)
#define GetAimCameraMatrix()          GetCurrentWorld().getAimCameraMatrix()
#define GetScreenRay()                GetCurrentWorld().getScreenRay()
#define GetMousePointerPos3D()        GetCurrentWorld().getMousePointerPos3D()
#define GetMousePointerPos2D()        GetCurrentWorld().getMousePointerPos2D()
#define GetCurrentFrame()             GetCurrentWorld().getCurrentFrame()

#define LoadGround(name)              GetCurrentWorld().loadGround(name)
#define LoadGroundTexture(name)       GetCurrentWorld().loadGroundTexture(name)
#define GetHeight(pos)                GetCurrentWorld().getHeight(pos)
#define GetRawHeight(pos)             GetCurrentWorld().getRawHeight(pos)
#define GetMapMin()                   GetCurrentWorld().getMapMin()
#define GetMapMax()                   GetCurrentWorld().getMapMax()
#define GetPathFinder()               GetCurrentWorld().getPathFinder()

#define GetIResourceManager()      GetIGame().getResourceManager()
#define GetPModel(name)            GetIResourceManager().getPModel(name)
#define GetAModel(name)            GetIResourceManager().getAModel(name)
#define GetCModel(name)            GetIResourceManager().getCModel(name)
#define LoadPolygonModel(name)     GetPolygonModel(name)
#define LoadAnimatedPolygon(name)  GetAnimatedPolygon(name)
#define CreateTexture(name)        GetIResourceManager().getTexture(name)

#define GetSoundPlayer() GetIGame().getSoundPlayer()
#define LoadSE(name)     GetSoundPlayer().loadSE(name)
#define PlaySE(name, c)  GetSoundPlayer().playSE(name, c)
#define LoadBGM(name)    GetSoundPlayer().loadBGM(name)
#define PlayBGM(name)    GetSoundPlayer().playBGM(name)
#define HaltBGM()        GetSoundPlayer().haltBGM()


#endif
