#ifndef IST_NET_H
#define IST_NET_H
#include "ist_conf.h"
#include "socket.h"
#include "bstream.h"

namespace ist {

typedef gimite::socket_stream TCPSocket;



class DSO_CLASS HTTP : public ist::Object
{
public:
	enum {
		OK = 200,
		NOT_FOUND = 404,
	};

	size_t respons;
	size_t clength;
	volatile size_t recieved;
	std::string ctype;

	std::string host;
	std::string path;
	std::string filename;
	ist::bbuffer content;
	ist::bstream *stream;

	HTTP();
	bool get(const std::string& url, unsigned short port=80);
	bool head(const std::string& url, unsigned short port=80);
	bool post(const std::string& url, const std::string& postdata, unsigned short port=80);
	bool operator!() const;
	ist::bbuffer& getContent();
	void setStream(ist::bstream& s);

	void clear();
	void splitURL(const std::string& url);
	void analyzeHead(TCPSocket& sst);
	void getContent(TCPSocket& sst);
};

} // ist 

#endif
