#ifndef IST_REF_COUNT_H
#define IST_REF_COUNT_H

#include <boost/intrusive_ptr.hpp>

namespace ist {

class DSO_CLASS Object
{
public:
	Object() : ref_count(0) {}
	virtual ~Object() {}

	void addRef() { ++ref_count; }
	void release() { if(--ref_count==0) delete this; }
	size_t getRefCount() { return ref_count; }

private:
	size_t ref_count;
};

} // ist

inline void intrusive_ptr_add_ref(ist::Object *p) { p->addRef(); }
inline void intrusive_ptr_release(ist::Object *p) { p->release(); }

#endif
