//---------------------------------------------------------------------------
//
// Name:        configDlg.cpp
// Author:      i-saint
// Created:     2005/08/15 12:21:08
//
//---------------------------------------------------------------------------

#include <set>
#include <fstream>
#include <sstream>
#include <wx/thread.h>
#include "ist/ist_net.h"
#include "ist/ist_sys.h"

#include "configDlg.h"
#include "../sys/config.h"
#include "../sys/lua_binder.h"

//Do not add custom headers.
//wx-dvcpp designer will remove them
////Header Include Start
////Header Include End



namespace {
	bool cond_start = true;
	wxTextCtrl *patch_log=0;
	wxGauge *gauge=0;

	void printLog(const std::string& mes) {
		patch_log->AppendText((mes+"\n").c_str());
		patch_log->ShowPosition(patch_log->GetValue().Length());
	}
}

class extracter : public ist::IGZExtracter
{
public:
	extracter(ist::bstream& bf) : ist::IGZExtracter(bf) {}
	virtual bool extractBuffer(const std::string& filename, ist::bbuffer& out) {
		bool res = false;
		if(res = ist::IGZExtracter::extractBuffer(filename, out))
			printLog(filename);
		else
			printLog("failed "+filename);
		return res;
	}
};



std::string patch_url;
std::set<std::string> patch_list;

class Downloader
{
public:
	ist::HTTP http;
	std::string url;
	volatile bool running;


	class dthread : public wxThread
	{
	public:
		Downloader *dp;
		dthread(Downloader *_d) : wxThread(), dp(_d) { }
		ExitCode Entry() {
			Downloader& d = *dp;

			d.http.get(d.url);
			d.running = false;
			return 0;
		}
	};

	Downloader(const std::string& u) : url(u), running(false) {
	}

	void run() {
		running = true;

		dthread *dt = new dthread(this);
		dt->Create();
		dt->Run();
	}
};


bool patch(const std::string& filename) {
	printLog(filename);
	Downloader d(patch_url+filename);
	d.run();
	while(d.running) {
		::wxMilliSleep(100);
		gauge->SetValue(int(float(d.http.recieved)/float(d.http.clength)*1000));
	}

	if(!!d.http) {
		extracter igz(d.http.getContent());
		igz.extractAllFiles();
	}
	else {
		printLog(filename+" ̃_E[hɎs܂BT[o[ŃAzȃ~X炩Ă܂܂B");
		return false;
	}
	return true;
}

void script() {
	std::fstream f("patchscript", std::ios::in | std::ios::binary);
	if(!!f) {
		std::string l;
		char command[32], arg[128];
		while(std::getline(f, l)) {
			printLog(l);
			if(sscanf(l.c_str(), "%s %[^\r]", command, arg)==2) {
				if(strcmp(command, "rm")==0)
					ist::Remove(arg);
				else if(strcmp(command, "mes")==0)
					printLog(arg);
				else if(strcmp(command, "exec")==0)
					wxExecute(arg, wxEXEC_SYNC);
				else if(strcmp(command, "execa")==0)
					wxExecute(arg, wxEXEC_ASYNC);
			}
		}
		f.close();
		ist::Remove("patchscript");
	}
}


void doPatch()
{
	gimite::startup_socket();

	{
		std::fstream f("patchconf", std::ios::in | std::ios::binary);
		std::string l;
		if(!!f && std::getline(f, l))
			patch_url = l;
		if(!patch_url.empty() && patch_url[patch_url.size()-1]=='\n')
			patch_url.erase(patch_url.end()-1);
		if(!patch_url.empty() && patch_url[patch_url.size()-1]=='\r')
			patch_url.erase(patch_url.end()-1);
	}

	{
		std::fstream f("patch", std::ios::in | std::ios::binary);
		std::string l;
		while(!!f && std::getline(f, l))
			patch_list.insert(l);
	}

	ist::HTTP h;
	h.get(patch_url+"patch");
	if(!!h) {
		std::stringstream ss(h.getContent().str());
		std::string l;
		while(std::getline(ss, l)) {
			if(l.empty() || l[0]=='\r' || (l[0]=='/' && l[1]=='/')) // sARgs 
				continue;
			if(l[l.size()-1]=='\n')
				l.erase(l.end()-1);
			if(l[l.size()-1]=='\r')
				l.erase(l.end()-1);
			if(patch_list.find(l)==patch_list.end() && patch(l)) {
				script();
				patch_list.insert(l);
			}
		}
	}
	else {
		printLog("pb`Xg̎擾Ɏs܂B");
	}

	{
		std::fstream f("patch", std::ios::out | std::ios::binary);
		for(std::set<std::string>::iterator p=patch_list.begin(); p!=patch_list.end(); ++p) {
			f << *p << std::endl;
		}
	}
	printLog("pb`Ƃ܂B");

	gimite::cleanup_socket();
}


//----------------------------------------------------------------------------
// configDlg
//----------------------------------------------------------------------------

   //Add Custom Events only in the appropriate Block.
   // Code added in  other places will be removed by wx-dvcpp 
////Event Table Start
BEGIN_EVENT_TABLE(configDlg,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(configDlg::configDlgClose)
	EVT_BUTTON(ID_WXBUTTON1,configDlg::BUOKClick)
END_EVENT_TABLE()
////Event Table End

configDlg::configDlg( wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style )
    : wxDialog( parent, id, title, position, size, style)
{
    CreateGUIControls();

	patch_log = TC_patch_status;
	gauge = G_patch;

	lua_binder_config();
	wxString temp;
	const FrameConfig& cf = GetFrameConfig();
	const GameConfig& gf = GetGameConfig();

	ED_player_name->SetValue(wxT(gf.player_name.c_str()));
	ED_font->SetValue(wxT(gf.system_font.c_str()));

	if(cf.width==1280)
		RB_res1280->SetValue(true);
	else if(cf.width==1024)
		RB_res1024->SetValue(true);
	else
		RB_res800->SetValue(true);

	if((cf.ex_flags & SDL_FULLSCREEN)!=0)
		CB_full_screen->SetValue(true);
	else
		CB_full_screen->SetValue(false);

	if(gf.frameskip)
		CB_frame_skip->SetValue(true);
	else
		CB_frame_skip->SetValue(false);

	if(gf.noeffect)
		CB_no_effect->SetValue(true);
	else
		CB_no_effect->SetValue(false);

	ED_server_database->SetValue(wxT(gf.server_database.c_str()));
	ED_server_address->SetValue(wxT(gf.server_address.c_str()));

	temp.Printf("%d", gf.port);
	ED_port->SetValue(temp);
}

configDlg::~configDlg()
{
} 

void configDlg::CreateGUIControls(void)
{
    //Do not add custom Code here
    //wx-devcpp designer will remove them.
    //Add the custom code before or after the Blocks
    ////GUI Items Creation Start

	this->SetSize(8,8,592,449);
	this->SetTitle(wxT("config"));
	this->Center();
	this->SetIcon(wxNullIcon);
	

	G_patch = new wxGauge(this, ID_G_PATCH, 1000, wxPoint(8,336), wxSize(302,17), wxGA_HORIZONTAL, wxDefaultValidator, wxT("G_patch"));
	G_patch->SetRange(1000);
	G_patch->SetValue(0);
	G_patch->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	TC_patch_status = new wxTextCtrl(this, ID_TC_PATCH_STATUS, wxT(""), wxPoint(8,16), wxSize(302,313), wxTE_READONLY | wxTE_MULTILINE, wxDefaultValidator, wxT("TC_patch_status"));
	TC_patch_status->SetMaxLength(0);
	TC_patch_status->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	WxStaticText2 = new wxStaticText(this, ID_WXSTATICTEXT2, wxT("server address"), wxPoint(325,330), wxSize(80,16), 0, wxT("WxStaticText2"));
	WxStaticText2->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	ED_server_address = new wxTextCtrl(this, ID_WXEDIT2, wxT("192.168.0.2"), wxPoint(330,352), wxSize(235,18), 0, wxDefaultValidator, wxT("ED_server_address"));
	ED_server_address->SetMaxLength(0);
	ED_server_address->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	ED_port = new wxTextCtrl(this, ID_ED_PORT, wxT("10031"), wxPoint(357,219), wxSize(45,18), 0, wxDefaultValidator, wxT("ED_port"));
	ED_port->SetMaxLength(0);
	ED_port->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("port"), wxPoint(325,220), wxSize(24,16), 0, wxT("WxStaticText1"));
	WxStaticText1->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	BUOK = new wxButton(this, ID_WXBUTTON1, wxT("Q[Jn"), wxPoint(121,377), wxSize(75,25), 0, wxDefaultValidator, wxT("BUOK"));
	BUOK->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	ED_server_port = new wxTextCtrl(this, ID_ED_SERVER_PORT, wxT("10031"), wxPoint(397,379), wxSize(45,18), 0, wxDefaultValidator, wxT("ED_server_port"));
	ED_server_port->SetMaxLength(0);
	ED_server_port->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	ED_server_database = new wxTextCtrl(this, ID_ED_SERVER_DATABASE, wxT("http://i-saint.skr.jp/empire_tohu/serverdb.cgi"), wxPoint(330,296), wxSize(235,18), 0, wxDefaultValidator, wxT("ED_server_database"));
	ED_server_database->SetMaxLength(0);
	ED_server_database->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	ED_font = new wxTextCtrl(this, ID_ED_FONT, wxT("resource/shnm12.f1b"), wxPoint(374,168), wxSize(145,18), 0, wxDefaultValidator, wxT("ED_font"));
	ED_font->SetMaxLength(0);
	ED_font->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	RB_res1280 = new wxRadioButton(this, ID_RB_RES1280, wxT("1280*1024"), wxPoint(325,142), wxSize(113,17), 0, wxDefaultValidator, wxT("RB_res1280"));
	RB_res1280->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	RB_res1024 = new wxRadioButton(this, ID_RB_RES1024, wxT("1024*768"), wxPoint(325,126), wxSize(113,17), 0, wxDefaultValidator, wxT("RB_res1024"));
	RB_res1024->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	RB_res800 = new wxRadioButton(this, ID_RB_RES800, wxT("800*600"), wxPoint(325,110), wxSize(113,17), 0, wxDefaultValidator, wxT("RB_res800"));
	RB_res800->SetValue(true);
	RB_res800->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	CB_no_effect = new wxCheckBox(this, ID_CB_NO_EFFECT, wxT("No Effect"), wxPoint(325,88), wxSize(97,17), 0, wxDefaultValidator, wxT("CB_no_effect"));
	CB_no_effect->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	CB_frame_skip = new wxCheckBox(this, ID_CB_FRAME_SKIP, wxT("Frame Skip"), wxPoint(325,70), wxSize(97,17), 0, wxDefaultValidator, wxT("CB_frame_skip"));
	CB_frame_skip->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	CB_full_screen = new wxCheckBox(this, ID_CB_FULL_SCREEN, wxT("Full Screen"), wxPoint(325,52), wxSize(97,17), 0, wxDefaultValidator, wxT("CB_full_screen"));
	CB_full_screen->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	ED_player_name = new wxTextCtrl(this, ID_ED_PLAYER_NAME, wxT("hoge"), wxPoint(395,7), wxSize(121,18), 0, wxDefaultValidator, wxT("ED_player_name"));
	ED_player_name->SetMaxLength(0);
	ED_player_name->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	WxStaticText6 = new wxStaticText(this, ID_WXSTATICTEXT6, wxT("font file"), wxPoint(325,168), wxSize(44,16), 0, wxT("WxStaticText6"));
	WxStaticText6->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	WxStaticText5 = new wxStaticText(this, ID_WXSTATICTEXT5, wxT("player name"), wxPoint(321,9), wxSize(66,16), 0, wxT("WxStaticText5"));
	WxStaticText5->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	WxStaticText4 = new wxStaticText(this, ID_WXSTATICTEXT4, wxT("server port"), wxPoint(325,380), wxSize(60,16), 0, wxT("WxStaticText4"));
	WxStaticText4->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	WxStaticText3 = new wxStaticText(this, ID_WXSTATICTEXT3, wxT("server database"), wxPoint(325,274), wxSize(86,16), 0, wxT("WxStaticText3"));
	WxStaticText3->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	WxStaticBox3 = new wxStaticBox(this, ID_WXSTATICBOX3, wxT("client"), wxPoint(318,252), wxSize(257,156));
	WxStaticBox3->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	WxStaticBox2 = new wxStaticBox(this, ID_WXSTATICBOX2, wxT("screen"), wxPoint(315,35), wxSize(261,159));
	WxStaticBox2->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));

	WxStaticBox1 = new wxStaticBox(this, ID_WXSTATICBOX1, wxT("server"), wxPoint(318,201), wxSize(257,47));
	WxStaticBox1->SetFont(wxFont(9, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("MS UI Gothic")));
    ////GUI Items Creation End
}

void configDlg::configDlgClose(wxCloseEvent& event)
{
    // --> Don't use Close with a wxDialog,
    // use Destroy instead.
    Destroy();
}


void configDlg::saveConfig(const char *filename)
{
	FrameConfig& cf = GetFrameConfig();
	GameConfig& gf = GetGameConfig();

	gf.player_name = ED_player_name->GetValue().c_str();
	gf.system_font = ED_font->GetValue().c_str();

	if(RB_res1280->GetValue()) {
		cf.width=1280; cf.height=1024;
	}
	else if(RB_res1024->GetValue()) {
		cf.width=1024; cf.height=768;
	}
	else {
		cf.width=800; cf.height=600;
	}

	if(CB_full_screen->IsChecked())
		cf.ex_flags|=SDL_FULLSCREEN;
	else
		cf.ex_flags = 0;

	if(CB_frame_skip->IsChecked())
		gf.frameskip = true;
	else
		gf.frameskip = false;

	if(CB_no_effect->IsChecked())
		gf.noeffect = true;
	else
		gf.noeffect = false;

	unsigned long temp = 0;
	gf.server_database = ED_server_database->GetValue().c_str();
	gf.server_address = ED_server_address->GetValue().c_str();
	if(ED_port->GetValue().ToULong(&temp))
		gf.port = temp;

	write_config(filename);
}

/*
 * BUOKClick
 */
void configDlg::BUOKClick(wxCommandEvent& event)
{
	// insert your code here
	saveConfig("config.lua");

	if(cond_start)
		wxExecute("empire_tohu", wxEXEC_ASYNC);

	Destroy();
}
