#ifndef EVENT_ROUTER_INCLUDE
#define EVENT_ROUTER_INCLUDE

#include <queue>
#include "aos/aos.h"



class IEventRouter : public ist::Object
{
public:
	virtual ~IEventRouter() {}
	
	virtual int getType() const=0;
	virtual void send(const Event& e)=0;
	virtual void update()=0;
	virtual void draw() const=0;
	virtual bool load(const std::string& filename)=0;

	virtual bool conditionToStart() const=0;
};


typedef boost::intrusive_ptr<IEventRouter> erouter_ptr;


erouter_ptr CreateEventRouter(int mode=SIMPLE);


#endif
