#include "input.h"


Input::Input(int id) :
	threthold(1000), joy(0)
{
	if(SDL_NumJoysticks()>id)
		joy = SDL_JoystickOpen(id);
}

Input::~Input()
{
	if(joy!=0)
		SDL_JoystickClose(joy);
}


void Input::update()
{
	in._button = 0;


	if(joy!=0) {
		in._button |= ((SDL_JoystickGetAxis(joy, 1) < -threthold) << 0);
		in._button |= ((SDL_JoystickGetAxis(joy, 1) >  threthold) << 1);
		in._button |= ((SDL_JoystickGetAxis(joy, 0) < -threthold) << 2);
		in._button |= ((SDL_JoystickGetAxis(joy, 0) >  threthold) << 3);

		for(int i=0; i<SDL_JoystickNumButtons(joy); ++i)
			in._button |= ((SDL_JoystickGetButton(joy, i)!=0) << (i+4));
	}
	{
		unsigned char *keystate = SDL_GetKeyState(0);
		in._button |= ((keystate[SDLK_w]!=0) << 0);
		in._button |= ((keystate[SDLK_s]!=0) << 1);
		in._button |= ((keystate[SDLK_a]!=0) << 2);
		in._button |= ((keystate[SDLK_d]!=0) << 3);

		in._button |= ((keystate[SDLK_j]!=0) << 4);
		in._button |= ((keystate[SDLK_k]!=0) << 5);
		in._button |= ((keystate[SDLK_l]!=0) << 6);
		in._button |= ((keystate[SDLK_i]!=0) << 7);
	}
}


bool Input::getAxis(int i)
{
	return in.axis(i);
}

bool Input::getButton(int i)
{
	return in.button(i);
}

