#ifndef INPUT_INCLUDE
#define INPUT_INCLUDE

#include <SDL/SDL.h>


struct input_t {
	input_t() : _button(0) {}

	bool up() const    { return (_button & 1)!=0; }
	bool down() const  { return (_button & 2)!=0; }
	bool right() const { return (_button & 4)!=0; }
	bool left() const  { return (_button & 8)!=0; }
	unsigned short axis() const   { return _button & 15; }
	unsigned short button() const { return _button ^ 15; }

	bool axis(unsigned int b) const {
		if(b>4)
			return false;
		return (_button & (1<<b))!=0;
	}

	bool button(unsigned int b) const {
		if(b>11)
			return false;
		return (_button & (1<<(b+4)))!=0;
	}

	bool operator==(const input_t &v) const { return (_button==v._button); }

	unsigned short _button;
};


class Input
{
public:
	Input(int id=0);
	~Input();

	void update();
	bool getAxis(int i);
	bool getButton(int i);

private:
	int threthold;
	input_t in;
	SDL_Joystick *joy;
};


#endif
