extern "C" {
	#include <lua.h>
	#include <lualib.h>
	#include <lauxlib.h>
}
#include <SDL/SDL.h>

#include "lua_binder.h"
#include "config.h"





int _load_dso(lua_State *L) {
	GetGameConfig().dso_list.push_back(lua_tostring(L, 1));
	return 0;
}


int _set_window_size(lua_State *L) {
	if(lua_isnumber(L, 1) && lua_isnumber(L, 2)) {
		GetFrameConfig().width = (int)lua_tonumber(L, 1);
		GetFrameConfig().height = (int)lua_tonumber(L, 2);
	}
	return 0;
}

int _enable_fullscreen(lua_State *L) {
	if(lua_toboolean(L, 1))
		GetFrameConfig().ex_flags|=SDL_FULLSCREEN;
	return 0;
}

int _enable_noeffect(lua_State *L) {
	GetGameConfig().noeffect = lua_toboolean(L, 1)!=0;
	return 0;
}

int _enable_frameskip(lua_State *L) {
	GetGameConfig().frameskip = lua_toboolean(L, 1)!=0;
	return 0;
}

int _enable_nowait(lua_State *L) {
	GetGameConfig().nowait = lua_toboolean(L, 1)!=0;
	return 0;
}

int _set_system_font(lua_State *L) {
	GetGameConfig().system_font = lua_tostring(L, 1);
	return 0;
}

int _set_port(lua_State *L) {
	GetGameConfig().port = (unsigned short)lua_tonumber(L, 1);
	return 0;
}

int _set_player_name(lua_State *L) {
	GetGameConfig().player_name = lua_tostring(L, 1);
	return 0;
}

int _set_server_database(lua_State *L) {
	GetGameConfig().server_database = lua_tostring(L, 1);
	return 0;
}

int _set_server_address(lua_State *L) {
	GetGameConfig().server_address = lua_tostring(L, 1);
	return 0;
}

int _set_server_port(lua_State *L) {
	GetGameConfig().server_port = (unsigned short)lua_tonumber(L, 1);
	return 0;
}

void lua_binder_config()
{
	lua_State *L = lua_open();
	lua_baselibopen(L);
	lua_register(L, "load_dso", _load_dso);
	lua_register(L, "set_player_name", _set_player_name);
	lua_register(L, "enable_fullscreen", _enable_fullscreen);
	lua_register(L, "enable_frameskip", _enable_frameskip);
	lua_register(L, "enable_nowait", _enable_nowait);
	lua_register(L, "enable_noeffect", _enable_noeffect);
	lua_register(L, "set_window_size", _set_window_size);
	lua_register(L, "set_system_font", _set_system_font);
	lua_register(L, "set_server_database", _set_server_database);
	lua_register(L, "set_server_address", _set_server_address);
	lua_register(L, "set_server_port", _set_server_port);
	lua_register(L, "set_port", _set_port);

	lua_dofile(L, "dso.lua");
	lua_dofile(L, "config.lua");
	lua_close(L);
}

