#include "resource_manager.h"


texture_ptr ResourceManager::getTexture(const std::string& name) {
	texture_cont::iterator p = texture.find(name);
	if(p!=texture.end()) {
		return p->second;
	}
	else {
		texture[name] = texture_ptr(new ist::Texture());
		return texture[name];
	}
}

pmodel_ptr ResourceManager::getPModel(const std::string& name) {
	pmodel_cont::iterator p = polygon.find(name);
	if(p!=polygon.end()) {
		return p->second;
	}
	else {
		pmodel_ptr mp(new ist::PolygonModel());
		mp->load(name);
		polygon[name] = mp;
		return polygon[name];
	}
}

amodel_ptr ResourceManager::getAModel(const std::string& name) {
	amodel_cont::iterator p = apolygon.find(name);
	if(p!=apolygon.end()) {
		return p->second;
	}
	else {
		amodel_ptr mp(new ist::MorphModel());
		mp->load(name);
		apolygon[name] = mp;
		return apolygon[name];
	}
}

cmodel_ptr ResourceManager::getCModel(const std::string& name) {
	cmodel_cont::iterator p = cpolygon.find(name);
	if(p!=cpolygon.end()) {
		return p->second;
	}
	else {
		cmodel_ptr mp(new ist::CachedMorphModel());
		mp->load(name);
		cpolygon[name] = mp;
		return cpolygon[name];
	}
}

void ResourceManager::clear() {
	texture.clear();
	polygon.clear();
	apolygon.clear();
}
