#ifndef RESOURCE_MANAGER_INCLUDE
#define RESOURCE_MANAGER_INCLUDE

#include <string>
#include <map>
#include "aos/aos.h"

class ResourceManager : public IResourceManager
{
public:
	ResourceManager() {}
	~ResourceManager() {}

	texture_ptr getTexture(const std::string& name);
	pmodel_ptr getPModel(const std::string& name);
	amodel_ptr getAModel(const std::string& name);
	cmodel_ptr getCModel(const std::string& name);
	void clear();

private:
	typedef std::map<std::string, texture_ptr> texture_cont;
	typedef std::map<std::string, pmodel_ptr>  pmodel_cont;
	typedef std::map<std::string, amodel_ptr>  amodel_cont;
	typedef std::map<std::string, cmodel_ptr>  cmodel_cont;
	texture_cont texture;
	pmodel_cont polygon;
	amodel_cont apolygon;
	cmodel_cont cpolygon;
};



#endif
