#include "ist/dso_setup.h"
#include "tohu_ruler.h"






class titleDaemon : public Menu
{
public:
	category_t getRecieveEvents() const { return RCV_KEY | RCV_BUTTON; }

	void onKey(Event& e) {
		Event::KeyInfo& info = e.getKeyInfo();
		if(info.state==SDL_KEYUP) {
			if(info.key==SDLK_ESCAPE) { Exit(); }
		}
	}
};




class ExitButton : public Button
{
public:
	ExitButton() {
		setTexture("resource/button_up.png");
		setTextureOver("resource/button_over.png");
		setRect(ist::vector2(120, 30));
	}
	void draw() const {
		Button::draw();
		const ist::vector2& pos = getPos();
		DrawFont((int)pos.x+45, (int)pos.y+10, "I");
	}
	void action() {
		Exit();
	}
};






class SinglePlayerButton : public Button
{
public:
	SinglePlayerButton() {
		setTexture("resource/button_up.png");
		setTextureOver("resource/button_over.png");
		setRect(ist::vector2(120, 30));
	}
	void draw() const {
		Button::draw();
		const ist::vector2& pos = getPos();
		DrawFont((int)pos.x+15, (int)pos.y+10, "VOvC[");
	}

	void action() {
		SetCurrentWorld("singleplayer");

		button_ptr b = CreateNormalBattleButton();
		b->setPos(ist::vector2(260, 300));
		AddGObj(b);

		b = CreateMuddyBattleButton();
		b->setPos(ist::vector2(260, 360));
		AddGObj(b);

		b = CreateReplayButton();
		b->setPos(ist::vector2(260, 420));
		AddGObj(b);
	}
};







class MultiPlayerButton : public Button
{
public:
	MultiPlayerButton() {
		setTexture("resource/button_up.png");
		setTextureOver("resource/button_over.png");
		setRect(ist::vector2(120, 30));
	}
	void draw() const {
		Button::draw();
		const ist::vector2& pos = getPos();
		DrawFont((int)pos.x+15, (int)pos.y+10, "}`vC[");
	}

	void action() {
		SetCurrentWorld("multiplayer");

		button_ptr b = CreateServerButton();
		b->setPos(ist::vector2(260, 300));
		AddGObj(b);

		b = CreateClientButton();
		b->setPos(ist::vector2(260, 360));
		AddGObj(b);

		b = CreateServerSelectButton();
		b->setPos(ist::vector2(260, 420));
		AddGObj(b);
	}
};






class titleScreen : public Menu
{
public:
	titleScreen() {
		texture = GetTexture("resource/title.png");

		button_ptr b = new SinglePlayerButton();
		b->setPos(ist::vector2(260, 300));
		AddGObj(b);

		b = new MultiPlayerButton();
		b->setPos(ist::vector2(260, 360));
		AddGObj(b);

		b = new ExitButton();
		b->setPos(ist::vector2(260, 420));
		AddGObj(b);
	}

	void draw() const {
		glEnable(GL_TEXTURE_2D);
		texture->assign();
		DrawRect(ist::vector2(0, 0), ist::vector2(640, 480));
		glDisable(GL_TEXTURE_2D);
	}

private:
	texture_ptr texture;
};








namespace {
	IGame *igame=0;
}
IGame& _GetIGame() { return *igame; }

DECLARE_DSO_ENTRYPOINT();

EXPORT void OnLoad(IGame& ig)
{
	ist::init();

	igame= &ig;

//	LoadDSO("tohu_faction.dso");
	SetCurrentWorld("title");
	AddGObj(new titleScreen());
	AddGObj(new titleDaemon());

	ist::quit();
}

