#ifndef TOHU_RULER
#define TOHU_RULER

#include "templates/game_object.h"




inline ist::vector4 RandomPos(float reduce=0) {
	ist::vector2 mmin = GetMapMin();
	ist::vector2 mmax = GetMapMax();

	mmin.x+=reduce;
	mmin.y+=reduce;
	mmax.x-=reduce;
	mmax.y-=reduce;
	return ist::vector4(mmin.x+GetRand()*(mmax.x-mmin.x), 0, mmin.y+GetRand()*(mmax.y-mmin.y));
}

inline ist::vector4 RandomAim() {
	return ist::vector4(GetRand()-0.5f, 0, GetRand()-0.5f);
}

typedef std::vector< std::pair<ist::vector4, bool> > Grid;
inline ist::vector4 getEmptyGrid(Grid& grid) {
	while(1) {
		int index = (int)(GetRand()*grid.size());
		if(!grid[index].second) {
			grid[index].second = true;
			return grid[index].first;
		}
	}
}

template<class T>
struct greater_vec4 {
	bool operator()(const T& lhs, const T& rhs) {
		ist::vector4 map(GetMapMax().x, 1000.0f, GetMapMax().y);
		return (lhs-map).square()>(rhs-map).square();
	}
};




button_ptr CreateNormalBattleButton();
button_ptr CreateMuddyBattleButton();
button_ptr CreateReplayButton();

button_ptr CreateServerButton();
button_ptr CreateClientButton();
button_ptr CreateServerSelectButton();

#endif
