#include "templates/equipment.h"

/*
class tohuGunBullet : public LinearInherit3(HaveBlendAddAttrib, HavePolygonModel, Bullet)
{
public:
	tohuGunBullet() :
		is_matrix_set(false)
	{
		setLifeTime(20);
		setSelectionRadius(5);
		setHitRadius(5);
		setPModel("resource/plane.mqo");
		setTexture("resource/tohu_bullet.png");
		setScl( ist::vector4(10.0f, 10.0f, 10.0f) );
	}

	void setMatrix(ist::matrix44& mat) {
		if(!is_matrix_set) {
			ist::vector4 unit_vel = ist::vector4(getVel()).normalize();
			ist::vector4 ax = ist::vector4().cross(unit_vel, ist::vector4(0, -1, 0));
			ist::vector4 up = ist::vector4().cross(unit_vel, ax);
			matrix.aimVector(up);
			if(unit_vel.y<0)
				matrix.rotateY(180);
			matrix.scale(getScl().v);
			is_matrix_set = true;
		}
		mat.translate(getPos().v);
		mat*=matrix;
	}

	void onCollide(Event& e) {
		SendKillEvent(this, this);
		gobj_ptr target = GetGObj(e.from);
		if(!!target)
			SendDamageEvent(getRoot(), target, getDamage());
		if(isInCameraSight()) {
			Flasher *p = new Flasher();
			AddGObj(p);
			p->setPos(getPos());
			p->setScl(ist::vector4(20, 20, 20));
		}
	}

	bool is_matrix_set;
	ist::matrix44 matrix;
};


class tohuEnergyBullet : public LinearInherit4(BillboardAttrib, HaveNoDepthAttrib, HavePolygonModel, Bullet)
{
public:
	tohuEnergyBullet() {
		setLifeTime(30);
		setSelectionRadius(5);
		setHitRadius(5);
		setPModel("resource/plane.mqo");
		setTexture("resource/tohu_ebullet.png");
		setScl( ist::vector4(8.0f, 8.0f, 8.0f) );
	}

	void onCollide(Event& e) {
		SendKillEvent(this, this);
		gobj_ptr target = GetGObj(e.from);
		if(!!target)
			SendDamageEvent(getRoot(), target, getDamage());

		if(isInCameraSight()) {
			Flasher *p = new Flasher();
			AddGObj(p);
			p->setPos(getPos());
			p->setScl(ist::vector4(25, 25, 25));
		}
	}
};


class tohuRayBullet : public LinearInherit3(HaveBlendAddAttrib, HavePolyLine, Bullet)
{
public:
	tohuRayBullet() : is_target_alive(true) {
		setLifeTime(120);
		setSelectionRadius(9);
		setHitRadius(9);
		setPolylineSize(10);
		setPolylineWidth(13);
		setTexture("resource/hl.png");
	}

	void raise() {
		BaseClass::raise();
		is_target_alive = true;
	}

	void searchTarget() {
		breakable_ptr target;
		float min_dist = 0;

		IGObjIterator& block = GetBlocksByRadius(getPos(), 400);
		while(block.hasNext()) {
			breakable_ptr p = ToBreakable(block.iterate());
			if(!!p && IsEnemy(getFaction(), p->getFaction()) && IsTargetable(p)) {
				float dist = (p->getPos()-this->getPos()).setY(0).norm();
				if(dist<300.0f && !target || dist<min_dist) {
					target = p;
					min_dist = dist;
				}
			}
		}
		if(!!target)
			setTarget(target);
	}

	void onUpdate(Event& e) {
		BaseClass::onUpdate(e);

		selectable_ptr target = getTarget();
		if(!!target) {
			if(!target->isDead()) {
				setVel((getVel()*0.93f) + (target->getPos()-getPos()).normalize()*1.2f);
				is_target_alive = true;
			}
		}
		else if(is_target_alive) {
			is_target_alive = false;
			searchTarget();
		}
	}

	void onCollide(Event& e) {
		SendKillEvent(this, this);
		gobj_ptr target = GetGObj(e.from);
		if(!!target)
			SendDamageEvent(getRoot(), target, getDamage());

		if(isInCameraSight()) {
			Flasher *p = new Flasher();
			AddGObj(p);
			p->setPos(getPos());
			p->setScl(ist::vector4(40, 40, 40));
		}
	}

private:
	bool is_target_alive;
};

class tohuBombBullet : public LinearInherit4(BillboardAttrib, HaveNoDepthAttrib, HavePolygonModel, Bullet)
{
public:
	tohuBombBullet() {
		setLifeTime(120);
		setSelectionRadius(10);
		setHitRadius(10);
		setPModel("resource/plane.mqo");
		setTexture("resource/tohu_ebulletr.png");
		setScl( ist::vector4(13.0f, 13.0f, 13.0f) );
	}

	void onCollide(Event& e) {
		SendKillEvent(this, this);
		gobj_ptr target = GetGObj(e.from);
		if(!!target)
			SendDamageEvent(getRoot(), target, getDamage());

		if(isInCameraSight()) {
			for(int i=0; i<3; ++i) {
				ExplodeParticle *p = new ExplodeParticle();
				AddGObj(p);
				p->setTexture("resource/explode1.png");
				p->setPos(getPos());
			}
			{
				Flasher *p = new Flasher();
				AddGObj(p);
				p->setPos(getPos());
				p->setScl(ist::vector4(20, 20, 20));
			}
		}
	}
};





class tohuGun1 : public IWeapon
{
public:
	tohuGun1() {
		setFirePower(1.0f*(50.0f/60.0f));
	}

	void fire(breakable_ptr target) {
		setCoolDown(50);

		tohuGunBullet *bul = new tohuGunBullet();
		AddGObj(bul);
		bul->setTarget(target);
		bul->setRoot(getRoot());
		bul->setPos(getFirePos());
		bul->setVel((getTarget()->getPos()-getFirePos()).normalize()*15.0f);
		bul->setDamage(new Event::DamageInfo(getRoot()->getFirePower(), 0, 0));
	}
};

class tohuEnergyShot1 : public IWeapon
{
public:
	tohuEnergyShot1() {
		setFirePower(0.5f*(40.0f/60.0f));
	}

	void fire(breakable_ptr target) {
		setCoolDown(40);

		tohuEnergyBullet *bul = new tohuEnergyBullet();
		AddGObj(bul);
		bul->setTarget(target);
		bul->setRoot(getRoot());
		bul->setPos(getFirePos());
		bul->setVel((target->getPos()-getFirePos()).normalize()*12.5f);
		bul->setDamage(new Event::DamageInfo(0, 0, 0, getRoot()->getFirePower()));
		setCoolDown(cool_down);
		setClipName("attack");
	}
};

class tohuSnake1 : public IWeapon
{
public:
	tohuSnake1() {
		setFirePower(1.0f*(90.0f/60.0f));
	}

	void fire(breakable_ptr target) {
		setCoolDown(90);

		tohuRayBullet *bul = new tohuRayBullet();
		AddGObj(bul);
		bul->setTarget(target);
		bul->setRoot(getRoot());
		bul->setPos(getFirePos());
		bul->setVel( ((target->getPos()-getFirePos()).normalize()*-25.0f).setY(15.0f) );
		bul->setDamage(new Event::DamageInfo(0, getRoot()->getFirePower(), 0));
	}
};

class tohuBomb1 : public IWeapon
{
public:
	tohuBomb1() {
		setFirePower(1.0f*(180.0f/60.0f));
	}

	void fire(breakable_ptr target) {
		setCoolDown(180);

		tohuBombBullet *b = new tohuBombBullet();
		AddGObj(b);
		b->setTarget(target);
		b->setRoot(getRoot());
		b->setPos(getFirePos());
		b->setVel((target->getPos()-getFirePos()).normalize()*5);
		b->setDamage(new Event::DamageInfo(0, 0, getRoot()->getFirePower()));
	}
};

*/
