#include "tohu.h"



class ClassInfo
{
public:
	ClassInfo() {}
	void setInfo(const std::string& n, const std::string& d, const std::string& i, const std::string& m) {
		name = n;
		description = d;
		icon_path = i;
		model_path = m;
	}

	std::string name;
	std::string description;
	std::string icon_path;
	std::string model_path;
};

const ClassInfo& getInfo(const std::string classname) {
	static std::map<std::string, ClassInfo> info;
	if(info.empty()) {
		info["tohuTownCenter"].setInfo(
			"̒̒S",
			"_YB",
			"resource/tohu_towncenter_icon.png",
			"resource/tohu_towncenter.mqo"
		);
		info["tohuSettlement"].setInfo(
			"̒",
			"̒ɁB",
			"resource/tohu_settlement_icon.png",
			"resource/tohu_settlement.mqo"
		);
		info["tohuPowerPlant"].setInfo(
			"̔d",
			"d{݁B\nGlM[iEnj𑝂₷B",
			"resource/tohu_power_plant_icon.png",
			"resource/tohu_power_plant.mqo"
		);
		info["tohuFactoryS"].setInfo(
			"̍H",
			"RjbgY{݁B\n^jbg̐YsB",
			"resource/tohu_factory_icon.png",
			"resource/tohu_factory.mqo"
		);
		info["tohuFactoryM"].setInfo(
			"̑^H",
			"RjbgY{݁B\n^jbg̐YsB",
			"resource/tohu_factory_l_icon.png",
			"resource/tohu_factory_l.mqo"
		);
		info["tohuFactoryL"].setInfo(
			"̑D",
			"DB^jbg̐YsB",
			"resource/tohu_factory_l_icon.png",
			"resource/tohu_factory_l.mqo"
		);
		info["tohuLaboratory"].setInfo(
			"̌",
			"{݁B\njbg̋\͂̕tsB",
			"resource/tohu_factory_l_icon.png",
			"resource/tohu_factory_l.mqo"
		);
		info["tohuTower"].setInfo(
			"̓",
			"LȎE炵A\nU\͂ȈՖhq_B",
			"resource/tohu_tower_icon.png",
			"resource/tohu_tower.mqo"
		);
		info["tohuCastle"].setInfo(
			"̏",
			"Ȗhq_B\n@łɒނ͎̂Esׂɋ߂B",
			"resource/tohu_castle_icon.png",
			"resource/tohu_castle.mqo"
		);



		info["tohuWorker"].setInfo(
			"",
			"݂Ǝ̎WsjbgB\nU\͎͂ȂB",
			"resource/tohu_worker_icon.png",
			""
		); 
		info["tohuSoldier1"].setInfo(
			"",
			"ėp̍URjbgB",
			"resource/tohu_soldier1_icon.png",
			""
		); 
		info["tohuSoldier2"].setInfo(
			"Ct@g[",
			"ėp̍URjbgB",
			"resource/tohu_soldier2_icon.png",
			""
		); 
		info["tohuSoldier3"].setInfo(
			"t@C^[",
			"ėp̍URjbgB",
			"resource/tohu_soldier3_icon.png",
			""
		); 
		info["tohuArmor1"].setInfo(
			"߉q",
			"ړx̓J^cȏɍU͂Ⴂ\nϋv͂ƂĂjbgB",
			"resource/tohu_armor1_icon.png",
			""
		); 
		info["tohuArmor2"].setInfo(
			"K[fBA",
			"ړx̓J^cȏɍU͂Ⴂ\nϋv͂ƂĂjbgB",
			"resource/tohu_armor2_icon.png",
			""
		); 
		info["tohuArmor3"].setInfo(
			"fBtFT[",
			"ړx̓J^cȏɍU͂Ⴂ\nϋv͂ƂĂjbgB",
			"resource/tohu_armor3_icon.png",
			""
		); 
		info["tohuLaser1"].setInfo(
			"[U[",
			"˒AU͂̂悤ȑϋv\n킹ĂȂxjbgB",
			"resource/tohu_laser1_icon.png",
			""
		); 
		info["tohuLaser2"].setInfo(
			"XiCp[",
			"˒AU͂̂悤ȑϋv\n킹ĂȂxjbgB",
			"resource/tohu_laser2_icon.png",
			""
		); 
		info["tohuLaser3"].setInfo(
			"V[^[",
			"˒AU͂̂悤ȑϋv\n킹ĂȂxjbgB",
			"resource/tohu_laser3_icon.png",
			""
		); 
		info["tohuHealer"].setInfo(
			"q[[",
			"U\͎͂ȂA\njbg񕜂\͂B",
			"resource/tohu_healer_icon.png",
			""
		); 
		info["tohuAssasin"].setInfo(
			"ÎE",
			"U͑ϋv͋ɒ߂A\nړxA\͂A\nh͖UsB",
			"resource/tohu_assasin_icon.png",
			""
		); 

		info["tohuBomber1"].setInfo(
			"",
			"Ό̃GLXp[gB\nȊOɑ΂Ă͂قږ́B",
			"resource/tohu_bomber_icon.png",
			""
		); 
		info["tohuArbalest"].setInfo(
			"֒eC",
			"ɔ͈͍UH킷CB\nړ[hƍU[hA\nU[ĥ݂UłȂB",
			"resource/tohu_arbalest_icon.png",
			""
		); 
		info["tohuTransporter"].setInfo(
			"]",
			"w肵jbgƁA̎͂̃jbg\n[vA@B",
			"resource/tohu_transporter_icon.png",
			""
		); 
		info["tohuMine"].setInfo(
			"@",
			"\͂UjbgB",
			"resource/tohu_shield_icon.png",
			""
		); 
		info["tohuDetector"].setInfo(
			"fBeN^[",
			"E̓G̃N[N\\͂B",
			"resource/tohu_transporter_icon.png",
			""
		); 


		info["tohuDestroyer"].setInfo(
			"fXgC[",
			"^A^jbgɐȔj͂𔭊쒀́B",
			"resource/no_image.png",
			""
		);
		info["tohuCruiser"].setInfo(
			"N[U[",
			"^jbgƌɐȔj͂𔭊鏄ḿB",
			"resource/no_image.png",
			""
		);
		info["tohuMovilFort"].setInfo(
			"@vǓ",
			"Ȏϋv͂ƁA^jbgY\͂@vǁB",
			"resource/no_image.png",
			""
		);

		info["tohuEmperor"].setInfo(
			"c铤",
			"Az݂HPA覐΂~点\nL͈͂ɍUĂ鋥ȃjbgB",
			"resource/tohu_emperor_icon.png",
			""
		); 




		info["tohuAgeOfTonyu"].setInfo(
			"̎",
			"苭͂ȕ쐬ł铤̎ւƐiB",
			"resource/no_image.png",
			""
		);
		info["tohuAgeOfTohu"].setInfo(
			"̎",
			"苭͂ȕ쐬ł铤̎ւƐiB",
			"resource/no_image.png",
			""
		);

		info["Gather1"].setInfo(
			"W",
			"̎WxオB\n(b2.0 > b2.5)",
			"resource/no_image.png",
			""
		);
		info["Gather2"].setInfo(
			"W",
			"̎WxオB\n(b2.5 > b3.0)",
			"resource/no_image.png",
			""
		);
		info["Gather3"].setInfo(
			"W",
			"̎WxオB\n(b3.0 > b3.5)",
			"resource/no_image.png",
			""
		);
		info["Carry1"].setInfo(
			"^",
			"̎^\͂オB\n(ő20 > ő30)",
			"resource/no_image.png",
			""
		);
		info["Carry2"].setInfo(
			"^",
			"̎^\͂オB\n(ő30 > ő40)",
			"resource/no_image.png",
			""
		);
		info["WorkerProtector"].setInfo(
			"_pveN^[",
			"̖h͂HPオB(+40/+15%/+15%)",
			"resource/no_image.png",
			""
		);

		info["Cloaking"].setInfo(
			"N[LOfoCX",
			"ÎEɃN[N\͂B",
			"resource/no_image.png",
			""
		);
		info["ConstantCloak"].setInfo(
			"RX^gN[N",
			"ÎEPvIɃN[Nł悤ɂȂ邪AőHP啝ɌB(-50)",
			"resource/no_image.png",
			""
		);
		info["Spying"].setInfo(
			"UH",
			"ɋU\͂B",
			"resource/no_image.png",
			""
		);

		info["ABSMissile"].setInfo(
			"Ί̓~TC",
			"߉q̐͂ɑ΂U͂啝ɏオB(x5)",
			"resource/no_image.png",
			""
		);
		info["EMPBarrage"].setInfo(
			"EMPo[W",
			"@ɁAēG֌WȂ͂̃jbgEN炷\͂tB\nʂHPEN̎cʂɔႷB",
			"resource/no_image.png",
			""
		);
		info["MinimapJammer"].setInfo(
			"[_[W}[",
			"@ɃW~O\͂tB\n10bԓGR̃~j}bv\𗐂B",
			"resource/no_image.png",
			""
		);
	}
	return info[classname];
}

const std::string& GetUnitName(const std::string& classname) {
	return getInfo(classname).name;
}

const std::string& GetDescription(const std::string& classname) {
	return getInfo(classname).description;
}

const std::string& GetUnitModel(const std::string& classname) {
	return getInfo(classname).model_path;
}

const std::string& GetUnitImage(const std::string& classname) {
	return getInfo(classname).icon_path;
}

